controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    public function actionEjerepaso1(){
        //llamar a una vista que me muestre un par de imagenes
        $fotos=[
            'f1.jpg',
            'f2.jpg',
        ];
        return $this->render('ejercicio1',[
            "fotos" => $fotos,
        ]);
    }
    public function actionEjerepaso2(){
        //llamar a una vista que me muestre titulo y contenido
        $datos=[
            "titulo" => "Ejemplo de Datos en MVC",
            "contenido" => "Este contenido se lo pasa el controlador a la vista"
        ];
        return $this->render('ejercicio2',[
            "titulo" => $datos["titulo"],
            "contenido" => $datos["contenido"]
        ]);
    }
    
    public function actionEjeform1() {
        //crear un objeto con el modelo Formulario1
         $model = new \app\models\Formulario1();
        
        //al if entra si has pulsado Enviar
        if ($model->load(Yii::$app->request->post())) {//cargar  los datos del formulario en el modelo
            if ($model->validate()) {//comprobar las reglas del modelo
                return $this->render("resultados",[
                    "model" => $model,
                ]);
            }
        }

        //carga el formulario vacio o con errores de validacion
        return $this->render('formulario1', [
            'model' => $model,
        ]);
    }
    
    public function actionEjeform2() {
        //cargar un formulario que me pida un texto
        //cuando escriba un texto y pulse enviar
        //me indica el numero de caracteres que tiene el texto
        //1_crear el modelo para este Formulario2
        //2_Iros a gii formulario2 vista
        //3_copiar en el gii la accion del controlador
        //4_pegar la accion aqui
        //5_crear en el modelo un metodo publico que retorne la longitud del texto escrito
        //6_Añadir en la accion la vista que muestra resultado(resultados2) y pasarle en modelo
         $model = new \app\models\Formulario2();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                return $this->render("resultados2",[
                    "model" => $model
                ]);
            }
        }

        return $this->render('formulario2', [
            'model' => $model,
        ]);
    }
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
              ['label' => 'Ejericicios de Repaso', 'items' =>[
                ['label' => 'Ejercicio 1', 'url' => ['/site/ejerepaso1']],
                ['label' => 'Ejercicio 2', 'url' => ['/site/ejerepaso2']],
            ]],
            ['label' => 'Ejericicios con Formularios', 'items' =>[
                ['label' => 'Ejercicio 1', 'url' => ['/site/ejeform1']],
                ['label' => 'Ejercicio 2', 'url' => ['/site/ejeform2']],
            ]],
         
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">&copy; My Company <?= date('Y') ?></p>
        <p class="float-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>